// Generated by the protocol buffer compiler.  DO NOT EDIT!
// source: Management.proto

package proto.management;

/**
 * Protobuf type {@code management.FriendUpdate}
 */
public final class FriendUpdate extends
        com.google.protobuf.GeneratedMessageV3 implements
        // @@protoc_insertion_point(message_implements:management.FriendUpdate)
        FriendUpdateOrBuilder {
    private static final long serialVersionUID = 0L;

    // Use FriendUpdate.newBuilder() to construct.
    private FriendUpdate(com.google.protobuf.GeneratedMessageV3.Builder<?> builder) {
        super(builder);
    }

    private FriendUpdate() {
        type_ = 0;
        username_ = "";
        friend_ = "";
    }

    @java.lang.Override
    @SuppressWarnings({"unused"})
    protected java.lang.Object newInstance(
            UnusedPrivateParameter unused) {
        return new FriendUpdate();
    }

    @java.lang.Override
    public final com.google.protobuf.UnknownFieldSet
    getUnknownFields() {
        return this.unknownFields;
    }

    private FriendUpdate(
            com.google.protobuf.CodedInputStream input,
            com.google.protobuf.ExtensionRegistryLite extensionRegistry)
            throws com.google.protobuf.InvalidProtocolBufferException {
        this();
        if (extensionRegistry == null) {
            throw new java.lang.NullPointerException();
        }
        int mutable_bitField0_ = 0;
        com.google.protobuf.UnknownFieldSet.Builder unknownFields =
                com.google.protobuf.UnknownFieldSet.newBuilder();
        try {
            boolean done = false;
            while (!done) {
                int tag = input.readTag();
                switch (tag) {
                    case 0:
                        done = true;
                        break;
                    case 8: {
                        int rawValue = input.readEnum();
                        @SuppressWarnings("deprecation")
                        proto.management.FriendUpdate.Type value = proto.management.FriendUpdate.Type.valueOf(rawValue);
                        if (value == null) {
                            unknownFields.mergeVarintField(1, rawValue);
                        } else {
                            bitField0_ |= 0x00000001;
                            type_ = rawValue;
                        }
                        break;
                    }
                    case 18: {
                        com.google.protobuf.ByteString bs = input.readBytes();
                        bitField0_ |= 0x00000002;
                        username_ = bs;
                        break;
                    }
                    case 26: {
                        com.google.protobuf.ByteString bs = input.readBytes();
                        bitField0_ |= 0x00000004;
                        friend_ = bs;
                        break;
                    }
                    default: {
                        if (!parseUnknownField(
                                input, unknownFields, extensionRegistry, tag)) {
                            done = true;
                        }
                        break;
                    }
                }
            }
        } catch (com.google.protobuf.InvalidProtocolBufferException e) {
            throw e.setUnfinishedMessage(this);
        } catch (java.io.IOException e) {
            throw new com.google.protobuf.InvalidProtocolBufferException(
                    e).setUnfinishedMessage(this);
        } finally {
            this.unknownFields = unknownFields.build();
            makeExtensionsImmutable();
        }
    }

    public static final com.google.protobuf.Descriptors.Descriptor
    getDescriptor() {
        return proto.management.ManagementProtos.internal_static_management_FriendUpdate_descriptor;
    }

    @java.lang.Override
    protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
    internalGetFieldAccessorTable() {
        return proto.management.ManagementProtos.internal_static_management_FriendUpdate_fieldAccessorTable
                .ensureFieldAccessorsInitialized(
                        proto.management.FriendUpdate.class, proto.management.FriendUpdate.Builder.class);
    }

    /**
     * Protobuf enum {@code management.FriendUpdate.Type}
     */
    public enum Type
            implements com.google.protobuf.ProtocolMessageEnum {
        /**
         * <code>ADD = 0;</code>
         */
        ADD(0),
        /**
         * <code>REMOVE = 1;</code>
         */
        REMOVE(1),
        ;

        /**
         * <code>ADD = 0;</code>
         */
        public static final int ADD_VALUE = 0;
        /**
         * <code>REMOVE = 1;</code>
         */
        public static final int REMOVE_VALUE = 1;


        public final int getNumber() {
            return value;
        }

        /**
         * @param value The numeric wire value of the corresponding enum entry.
         * @return The enum associated with the given numeric wire value.
         * @deprecated Use {@link #forNumber(int)} instead.
         */
        @java.lang.Deprecated
        public static Type valueOf(int value) {
            return forNumber(value);
        }

        /**
         * @param value The numeric wire value of the corresponding enum entry.
         * @return The enum associated with the given numeric wire value.
         */
        public static Type forNumber(int value) {
            switch (value) {
                case 0:
                    return ADD;
                case 1:
                    return REMOVE;
                default:
                    return null;
            }
        }

        public static com.google.protobuf.Internal.EnumLiteMap<Type>
        internalGetValueMap() {
            return internalValueMap;
        }

        private static final com.google.protobuf.Internal.EnumLiteMap<
                Type> internalValueMap =
                new com.google.protobuf.Internal.EnumLiteMap<Type>() {
                    public Type findValueByNumber(int number) {
                        return Type.forNumber(number);
                    }
                };

        public final com.google.protobuf.Descriptors.EnumValueDescriptor
        getValueDescriptor() {
            return getDescriptor().getValues().get(ordinal());
        }

        public final com.google.protobuf.Descriptors.EnumDescriptor
        getDescriptorForType() {
            return getDescriptor();
        }

        public static final com.google.protobuf.Descriptors.EnumDescriptor
        getDescriptor() {
            return proto.management.FriendUpdate.getDescriptor().getEnumTypes().get(0);
        }

        private static final Type[] VALUES = values();

        public static Type valueOf(
                com.google.protobuf.Descriptors.EnumValueDescriptor desc) {
            if (desc.getType() != getDescriptor()) {
                throw new java.lang.IllegalArgumentException(
                        "EnumValueDescriptor is not for this type.");
            }
            return VALUES[desc.getIndex()];
        }

        private final int value;

        private Type(int value) {
            this.value = value;
        }

        // @@protoc_insertion_point(enum_scope:management.FriendUpdate.Type)
    }

    private int bitField0_;
    public static final int TYPE_FIELD_NUMBER = 1;
    private int type_;

    /**
     * <code>required .management.FriendUpdate.Type type = 1;</code>
     *
     * @return Whether the type field is set.
     */
    @java.lang.Override
    public boolean hasType() {
        return ((bitField0_ & 0x00000001) != 0);
    }

    /**
     * <code>required .management.FriendUpdate.Type type = 1;</code>
     *
     * @return The type.
     */
    @java.lang.Override
    public proto.management.FriendUpdate.Type getType() {
        @SuppressWarnings("deprecation")
        proto.management.FriendUpdate.Type result = proto.management.FriendUpdate.Type.valueOf(type_);
        return result == null ? proto.management.FriendUpdate.Type.ADD : result;
    }

    public static final int USERNAME_FIELD_NUMBER = 2;
    private volatile java.lang.Object username_;

    /**
     * <code>required string username = 2;</code>
     *
     * @return Whether the username field is set.
     */
    @java.lang.Override
    public boolean hasUsername() {
        return ((bitField0_ & 0x00000002) != 0);
    }

    /**
     * <code>required string username = 2;</code>
     *
     * @return The username.
     */
    @java.lang.Override
    public java.lang.String getUsername() {
        java.lang.Object ref = username_;
        if (ref instanceof java.lang.String) {
            return (java.lang.String) ref;
        } else {
            com.google.protobuf.ByteString bs =
                    (com.google.protobuf.ByteString) ref;
            java.lang.String s = bs.toStringUtf8();
            if (bs.isValidUtf8()) {
                username_ = s;
            }
            return s;
        }
    }

    /**
     * <code>required string username = 2;</code>
     *
     * @return The bytes for username.
     */
    @java.lang.Override
    public com.google.protobuf.ByteString
    getUsernameBytes() {
        java.lang.Object ref = username_;
        if (ref instanceof java.lang.String) {
            com.google.protobuf.ByteString b =
                    com.google.protobuf.ByteString.copyFromUtf8(
                            (java.lang.String) ref);
            username_ = b;
            return b;
        } else {
            return (com.google.protobuf.ByteString) ref;
        }
    }

    public static final int FRIEND_FIELD_NUMBER = 3;
    private volatile java.lang.Object friend_;

    /**
     * <code>required string friend = 3;</code>
     *
     * @return Whether the friend field is set.
     */
    @java.lang.Override
    public boolean hasFriend() {
        return ((bitField0_ & 0x00000004) != 0);
    }

    /**
     * <code>required string friend = 3;</code>
     *
     * @return The friend.
     */
    @java.lang.Override
    public java.lang.String getFriend() {
        java.lang.Object ref = friend_;
        if (ref instanceof java.lang.String) {
            return (java.lang.String) ref;
        } else {
            com.google.protobuf.ByteString bs =
                    (com.google.protobuf.ByteString) ref;
            java.lang.String s = bs.toStringUtf8();
            if (bs.isValidUtf8()) {
                friend_ = s;
            }
            return s;
        }
    }

    /**
     * <code>required string friend = 3;</code>
     *
     * @return The bytes for friend.
     */
    @java.lang.Override
    public com.google.protobuf.ByteString
    getFriendBytes() {
        java.lang.Object ref = friend_;
        if (ref instanceof java.lang.String) {
            com.google.protobuf.ByteString b =
                    com.google.protobuf.ByteString.copyFromUtf8(
                            (java.lang.String) ref);
            friend_ = b;
            return b;
        } else {
            return (com.google.protobuf.ByteString) ref;
        }
    }

    private byte memoizedIsInitialized = -1;

    @java.lang.Override
    public final boolean isInitialized() {
        byte isInitialized = memoizedIsInitialized;
        if (isInitialized == 1) return true;
        if (isInitialized == 0) return false;

        if (!hasType()) {
            memoizedIsInitialized = 0;
            return false;
        }
        if (!hasUsername()) {
            memoizedIsInitialized = 0;
            return false;
        }
        if (!hasFriend()) {
            memoizedIsInitialized = 0;
            return false;
        }
        memoizedIsInitialized = 1;
        return true;
    }

    @java.lang.Override
    public void writeTo(com.google.protobuf.CodedOutputStream output)
            throws java.io.IOException {
        if (((bitField0_ & 0x00000001) != 0)) {
            output.writeEnum(1, type_);
        }
        if (((bitField0_ & 0x00000002) != 0)) {
            com.google.protobuf.GeneratedMessageV3.writeString(output, 2, username_);
        }
        if (((bitField0_ & 0x00000004) != 0)) {
            com.google.protobuf.GeneratedMessageV3.writeString(output, 3, friend_);
        }
        unknownFields.writeTo(output);
    }

    @java.lang.Override
    public int getSerializedSize() {
        int size = memoizedSize;
        if (size != -1) return size;

        size = 0;
        if (((bitField0_ & 0x00000001) != 0)) {
            size += com.google.protobuf.CodedOutputStream
                    .computeEnumSize(1, type_);
        }
        if (((bitField0_ & 0x00000002) != 0)) {
            size += com.google.protobuf.GeneratedMessageV3.computeStringSize(2, username_);
        }
        if (((bitField0_ & 0x00000004) != 0)) {
            size += com.google.protobuf.GeneratedMessageV3.computeStringSize(3, friend_);
        }
        size += unknownFields.getSerializedSize();
        memoizedSize = size;
        return size;
    }

    @java.lang.Override
    public boolean equals(final java.lang.Object obj) {
        if (obj == this) {
            return true;
        }
        if (!(obj instanceof proto.management.FriendUpdate)) {
            return super.equals(obj);
        }
        proto.management.FriendUpdate other = (proto.management.FriendUpdate) obj;

        if (hasType() != other.hasType()) return false;
        if (hasType()) {
            if (type_ != other.type_) return false;
        }
        if (hasUsername() != other.hasUsername()) return false;
        if (hasUsername()) {
            if (!getUsername()
                    .equals(other.getUsername())) return false;
        }
        if (hasFriend() != other.hasFriend()) return false;
        if (hasFriend()) {
            if (!getFriend()
                    .equals(other.getFriend())) return false;
        }
        if (!unknownFields.equals(other.unknownFields)) return false;
        return true;
    }

    @java.lang.Override
    public int hashCode() {
        if (memoizedHashCode != 0) {
            return memoizedHashCode;
        }
        int hash = 41;
        hash = (19 * hash) + getDescriptor().hashCode();
        if (hasType()) {
            hash = (37 * hash) + TYPE_FIELD_NUMBER;
            hash = (53 * hash) + type_;
        }
        if (hasUsername()) {
            hash = (37 * hash) + USERNAME_FIELD_NUMBER;
            hash = (53 * hash) + getUsername().hashCode();
        }
        if (hasFriend()) {
            hash = (37 * hash) + FRIEND_FIELD_NUMBER;
            hash = (53 * hash) + getFriend().hashCode();
        }
        hash = (29 * hash) + unknownFields.hashCode();
        memoizedHashCode = hash;
        return hash;
    }

    public static proto.management.FriendUpdate parseFrom(
            java.nio.ByteBuffer data)
            throws com.google.protobuf.InvalidProtocolBufferException {
        return PARSER.parseFrom(data);
    }

    public static proto.management.FriendUpdate parseFrom(
            java.nio.ByteBuffer data,
            com.google.protobuf.ExtensionRegistryLite extensionRegistry)
            throws com.google.protobuf.InvalidProtocolBufferException {
        return PARSER.parseFrom(data, extensionRegistry);
    }

    public static proto.management.FriendUpdate parseFrom(
            com.google.protobuf.ByteString data)
            throws com.google.protobuf.InvalidProtocolBufferException {
        return PARSER.parseFrom(data);
    }

    public static proto.management.FriendUpdate parseFrom(
            com.google.protobuf.ByteString data,
            com.google.protobuf.ExtensionRegistryLite extensionRegistry)
            throws com.google.protobuf.InvalidProtocolBufferException {
        return PARSER.parseFrom(data, extensionRegistry);
    }

    public static proto.management.FriendUpdate parseFrom(byte[] data)
            throws com.google.protobuf.InvalidProtocolBufferException {
        return PARSER.parseFrom(data);
    }

    public static proto.management.FriendUpdate parseFrom(
            byte[] data,
            com.google.protobuf.ExtensionRegistryLite extensionRegistry)
            throws com.google.protobuf.InvalidProtocolBufferException {
        return PARSER.parseFrom(data, extensionRegistry);
    }

    public static proto.management.FriendUpdate parseFrom(java.io.InputStream input)
            throws java.io.IOException {
        return com.google.protobuf.GeneratedMessageV3
                .parseWithIOException(PARSER, input);
    }

    public static proto.management.FriendUpdate parseFrom(
            java.io.InputStream input,
            com.google.protobuf.ExtensionRegistryLite extensionRegistry)
            throws java.io.IOException {
        return com.google.protobuf.GeneratedMessageV3
                .parseWithIOException(PARSER, input, extensionRegistry);
    }

    public static proto.management.FriendUpdate parseDelimitedFrom(java.io.InputStream input)
            throws java.io.IOException {
        return com.google.protobuf.GeneratedMessageV3
                .parseDelimitedWithIOException(PARSER, input);
    }

    public static proto.management.FriendUpdate parseDelimitedFrom(
            java.io.InputStream input,
            com.google.protobuf.ExtensionRegistryLite extensionRegistry)
            throws java.io.IOException {
        return com.google.protobuf.GeneratedMessageV3
                .parseDelimitedWithIOException(PARSER, input, extensionRegistry);
    }

    public static proto.management.FriendUpdate parseFrom(
            com.google.protobuf.CodedInputStream input)
            throws java.io.IOException {
        return com.google.protobuf.GeneratedMessageV3
                .parseWithIOException(PARSER, input);
    }

    public static proto.management.FriendUpdate parseFrom(
            com.google.protobuf.CodedInputStream input,
            com.google.protobuf.ExtensionRegistryLite extensionRegistry)
            throws java.io.IOException {
        return com.google.protobuf.GeneratedMessageV3
                .parseWithIOException(PARSER, input, extensionRegistry);
    }

    @java.lang.Override
    public Builder newBuilderForType() {
        return newBuilder();
    }

    public static Builder newBuilder() {
        return DEFAULT_INSTANCE.toBuilder();
    }

    public static Builder newBuilder(proto.management.FriendUpdate prototype) {
        return DEFAULT_INSTANCE.toBuilder().mergeFrom(prototype);
    }

    @java.lang.Override
    public Builder toBuilder() {
        return this == DEFAULT_INSTANCE
                ? new Builder() : new Builder().mergeFrom(this);
    }

    @java.lang.Override
    protected Builder newBuilderForType(
            com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
        Builder builder = new Builder(parent);
        return builder;
    }

    /**
     * Protobuf type {@code management.FriendUpdate}
     */
    public static final class Builder extends
            com.google.protobuf.GeneratedMessageV3.Builder<Builder> implements
            // @@protoc_insertion_point(builder_implements:management.FriendUpdate)
            proto.management.FriendUpdateOrBuilder {
        public static final com.google.protobuf.Descriptors.Descriptor
        getDescriptor() {
            return proto.management.ManagementProtos.internal_static_management_FriendUpdate_descriptor;
        }

        @java.lang.Override
        protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
        internalGetFieldAccessorTable() {
            return proto.management.ManagementProtos.internal_static_management_FriendUpdate_fieldAccessorTable
                    .ensureFieldAccessorsInitialized(
                            proto.management.FriendUpdate.class, proto.management.FriendUpdate.Builder.class);
        }

        // Construct using proto.management.FriendUpdate.newBuilder()
        private Builder() {
            maybeForceBuilderInitialization();
        }

        private Builder(
                com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
            super(parent);
            maybeForceBuilderInitialization();
        }

        private void maybeForceBuilderInitialization() {
            if (com.google.protobuf.GeneratedMessageV3
                    .alwaysUseFieldBuilders) {
            }
        }

        @java.lang.Override
        public Builder clear() {
            super.clear();
            type_ = 0;
            bitField0_ = (bitField0_ & ~0x00000001);
            username_ = "";
            bitField0_ = (bitField0_ & ~0x00000002);
            friend_ = "";
            bitField0_ = (bitField0_ & ~0x00000004);
            return this;
        }

        @java.lang.Override
        public com.google.protobuf.Descriptors.Descriptor
        getDescriptorForType() {
            return proto.management.ManagementProtos.internal_static_management_FriendUpdate_descriptor;
        }

        @java.lang.Override
        public proto.management.FriendUpdate getDefaultInstanceForType() {
            return proto.management.FriendUpdate.getDefaultInstance();
        }

        @java.lang.Override
        public proto.management.FriendUpdate build() {
            proto.management.FriendUpdate result = buildPartial();
            if (!result.isInitialized()) {
                throw newUninitializedMessageException(result);
            }
            return result;
        }

        @java.lang.Override
        public proto.management.FriendUpdate buildPartial() {
            proto.management.FriendUpdate result = new proto.management.FriendUpdate(this);
            int from_bitField0_ = bitField0_;
            int to_bitField0_ = 0;
            if (((from_bitField0_ & 0x00000001) != 0)) {
                to_bitField0_ |= 0x00000001;
            }
            result.type_ = type_;
            if (((from_bitField0_ & 0x00000002) != 0)) {
                to_bitField0_ |= 0x00000002;
            }
            result.username_ = username_;
            if (((from_bitField0_ & 0x00000004) != 0)) {
                to_bitField0_ |= 0x00000004;
            }
            result.friend_ = friend_;
            result.bitField0_ = to_bitField0_;
            onBuilt();
            return result;
        }

        @java.lang.Override
        public Builder clone() {
            return super.clone();
        }

        @java.lang.Override
        public Builder setField(
                com.google.protobuf.Descriptors.FieldDescriptor field,
                java.lang.Object value) {
            return super.setField(field, value);
        }

        @java.lang.Override
        public Builder clearField(
                com.google.protobuf.Descriptors.FieldDescriptor field) {
            return super.clearField(field);
        }

        @java.lang.Override
        public Builder clearOneof(
                com.google.protobuf.Descriptors.OneofDescriptor oneof) {
            return super.clearOneof(oneof);
        }

        @java.lang.Override
        public Builder setRepeatedField(
                com.google.protobuf.Descriptors.FieldDescriptor field,
                int index, java.lang.Object value) {
            return super.setRepeatedField(field, index, value);
        }

        @java.lang.Override
        public Builder addRepeatedField(
                com.google.protobuf.Descriptors.FieldDescriptor field,
                java.lang.Object value) {
            return super.addRepeatedField(field, value);
        }

        @java.lang.Override
        public Builder mergeFrom(com.google.protobuf.Message other) {
            if (other instanceof proto.management.FriendUpdate) {
                return mergeFrom((proto.management.FriendUpdate) other);
            } else {
                super.mergeFrom(other);
                return this;
            }
        }

        public Builder mergeFrom(proto.management.FriendUpdate other) {
            if (other == proto.management.FriendUpdate.getDefaultInstance()) return this;
            if (other.hasType()) {
                setType(other.getType());
            }
            if (other.hasUsername()) {
                bitField0_ |= 0x00000002;
                username_ = other.username_;
                onChanged();
            }
            if (other.hasFriend()) {
                bitField0_ |= 0x00000004;
                friend_ = other.friend_;
                onChanged();
            }
            this.mergeUnknownFields(other.unknownFields);
            onChanged();
            return this;
        }

        @java.lang.Override
        public final boolean isInitialized() {
            if (!hasType()) {
                return false;
            }
            if (!hasUsername()) {
                return false;
            }
            if (!hasFriend()) {
                return false;
            }
            return true;
        }

        @java.lang.Override
        public Builder mergeFrom(
                com.google.protobuf.CodedInputStream input,
                com.google.protobuf.ExtensionRegistryLite extensionRegistry)
                throws java.io.IOException {
            proto.management.FriendUpdate parsedMessage = null;
            try {
                parsedMessage = PARSER.parsePartialFrom(input, extensionRegistry);
            } catch (com.google.protobuf.InvalidProtocolBufferException e) {
                parsedMessage = (proto.management.FriendUpdate) e.getUnfinishedMessage();
                throw e.unwrapIOException();
            } finally {
                if (parsedMessage != null) {
                    mergeFrom(parsedMessage);
                }
            }
            return this;
        }

        private int bitField0_;

        private int type_ = 0;

        /**
         * <code>required .management.FriendUpdate.Type type = 1;</code>
         *
         * @return Whether the type field is set.
         */
        @java.lang.Override
        public boolean hasType() {
            return ((bitField0_ & 0x00000001) != 0);
        }

        /**
         * <code>required .management.FriendUpdate.Type type = 1;</code>
         *
         * @return The type.
         */
        @java.lang.Override
        public proto.management.FriendUpdate.Type getType() {
            @SuppressWarnings("deprecation")
            proto.management.FriendUpdate.Type result = proto.management.FriendUpdate.Type.valueOf(type_);
            return result == null ? proto.management.FriendUpdate.Type.ADD : result;
        }

        /**
         * <code>required .management.FriendUpdate.Type type = 1;</code>
         *
         * @param value The type to set.
         * @return This builder for chaining.
         */
        public Builder setType(proto.management.FriendUpdate.Type value) {
            if (value == null) {
                throw new NullPointerException();
            }
            bitField0_ |= 0x00000001;
            type_ = value.getNumber();
            onChanged();
            return this;
        }

        /**
         * <code>required .management.FriendUpdate.Type type = 1;</code>
         *
         * @return This builder for chaining.
         */
        public Builder clearType() {
            bitField0_ = (bitField0_ & ~0x00000001);
            type_ = 0;
            onChanged();
            return this;
        }

        private java.lang.Object username_ = "";

        /**
         * <code>required string username = 2;</code>
         *
         * @return Whether the username field is set.
         */
        public boolean hasUsername() {
            return ((bitField0_ & 0x00000002) != 0);
        }

        /**
         * <code>required string username = 2;</code>
         *
         * @return The username.
         */
        public java.lang.String getUsername() {
            java.lang.Object ref = username_;
            if (!(ref instanceof java.lang.String)) {
                com.google.protobuf.ByteString bs =
                        (com.google.protobuf.ByteString) ref;
                java.lang.String s = bs.toStringUtf8();
                if (bs.isValidUtf8()) {
                    username_ = s;
                }
                return s;
            } else {
                return (java.lang.String) ref;
            }
        }

        /**
         * <code>required string username = 2;</code>
         *
         * @return The bytes for username.
         */
        public com.google.protobuf.ByteString
        getUsernameBytes() {
            java.lang.Object ref = username_;
            if (ref instanceof String) {
                com.google.protobuf.ByteString b =
                        com.google.protobuf.ByteString.copyFromUtf8(
                                (java.lang.String) ref);
                username_ = b;
                return b;
            } else {
                return (com.google.protobuf.ByteString) ref;
            }
        }

        /**
         * <code>required string username = 2;</code>
         *
         * @param value The username to set.
         * @return This builder for chaining.
         */
        public Builder setUsername(
                java.lang.String value) {
            if (value == null) {
                throw new NullPointerException();
            }
            bitField0_ |= 0x00000002;
            username_ = value;
            onChanged();
            return this;
        }

        /**
         * <code>required string username = 2;</code>
         *
         * @return This builder for chaining.
         */
        public Builder clearUsername() {
            bitField0_ = (bitField0_ & ~0x00000002);
            username_ = getDefaultInstance().getUsername();
            onChanged();
            return this;
        }

        /**
         * <code>required string username = 2;</code>
         *
         * @param value The bytes for username to set.
         * @return This builder for chaining.
         */
        public Builder setUsernameBytes(
                com.google.protobuf.ByteString value) {
            if (value == null) {
                throw new NullPointerException();
            }
            bitField0_ |= 0x00000002;
            username_ = value;
            onChanged();
            return this;
        }

        private java.lang.Object friend_ = "";

        /**
         * <code>required string friend = 3;</code>
         *
         * @return Whether the friend field is set.
         */
        public boolean hasFriend() {
            return ((bitField0_ & 0x00000004) != 0);
        }

        /**
         * <code>required string friend = 3;</code>
         *
         * @return The friend.
         */
        public java.lang.String getFriend() {
            java.lang.Object ref = friend_;
            if (!(ref instanceof java.lang.String)) {
                com.google.protobuf.ByteString bs =
                        (com.google.protobuf.ByteString) ref;
                java.lang.String s = bs.toStringUtf8();
                if (bs.isValidUtf8()) {
                    friend_ = s;
                }
                return s;
            } else {
                return (java.lang.String) ref;
            }
        }

        /**
         * <code>required string friend = 3;</code>
         *
         * @return The bytes for friend.
         */
        public com.google.protobuf.ByteString
        getFriendBytes() {
            java.lang.Object ref = friend_;
            if (ref instanceof String) {
                com.google.protobuf.ByteString b =
                        com.google.protobuf.ByteString.copyFromUtf8(
                                (java.lang.String) ref);
                friend_ = b;
                return b;
            } else {
                return (com.google.protobuf.ByteString) ref;
            }
        }

        /**
         * <code>required string friend = 3;</code>
         *
         * @param value The friend to set.
         * @return This builder for chaining.
         */
        public Builder setFriend(
                java.lang.String value) {
            if (value == null) {
                throw new NullPointerException();
            }
            bitField0_ |= 0x00000004;
            friend_ = value;
            onChanged();
            return this;
        }

        /**
         * <code>required string friend = 3;</code>
         *
         * @return This builder for chaining.
         */
        public Builder clearFriend() {
            bitField0_ = (bitField0_ & ~0x00000004);
            friend_ = getDefaultInstance().getFriend();
            onChanged();
            return this;
        }

        /**
         * <code>required string friend = 3;</code>
         *
         * @param value The bytes for friend to set.
         * @return This builder for chaining.
         */
        public Builder setFriendBytes(
                com.google.protobuf.ByteString value) {
            if (value == null) {
                throw new NullPointerException();
            }
            bitField0_ |= 0x00000004;
            friend_ = value;
            onChanged();
            return this;
        }

        @java.lang.Override
        public final Builder setUnknownFields(
                final com.google.protobuf.UnknownFieldSet unknownFields) {
            return super.setUnknownFields(unknownFields);
        }

        @java.lang.Override
        public final Builder mergeUnknownFields(
                final com.google.protobuf.UnknownFieldSet unknownFields) {
            return super.mergeUnknownFields(unknownFields);
        }


        // @@protoc_insertion_point(builder_scope:management.FriendUpdate)
    }

    // @@protoc_insertion_point(class_scope:management.FriendUpdate)
    private static final proto.management.FriendUpdate DEFAULT_INSTANCE;

    static {
        DEFAULT_INSTANCE = new proto.management.FriendUpdate();
    }

    public static proto.management.FriendUpdate getDefaultInstance() {
        return DEFAULT_INSTANCE;
    }

    @java.lang.Deprecated
    public static final com.google.protobuf.Parser<FriendUpdate>
            PARSER = new com.google.protobuf.AbstractParser<FriendUpdate>() {
        @java.lang.Override
        public FriendUpdate parsePartialFrom(
                com.google.protobuf.CodedInputStream input,
                com.google.protobuf.ExtensionRegistryLite extensionRegistry)
                throws com.google.protobuf.InvalidProtocolBufferException {
            return new FriendUpdate(input, extensionRegistry);
        }
    };

    public static com.google.protobuf.Parser<FriendUpdate> parser() {
        return PARSER;
    }

    @java.lang.Override
    public com.google.protobuf.Parser<FriendUpdate> getParserForType() {
        return PARSER;
    }

    @java.lang.Override
    public proto.management.FriendUpdate getDefaultInstanceForType() {
        return DEFAULT_INSTANCE;
    }

}

